Scriptname DovahkiinLevitate extends activemagiceffect  

import Utility
import form
import game
import debug

Actor Property Player Auto 

PROJECTILE Property myProjectile  Auto 

ObjectReference Property TransportTarget  Auto
ObjectReference Property TransportArrow  Auto 

VisualEffect Property myVisualEffect  Auto  
Activator Property mySummonFX  Auto  

SPELL Property myTimeWarpSpell  Auto  

Explosion Property myExplosion  Auto  

float property skillAdvancement = 5.0 auto

Event OnEffectStart(Actor akTarget, Actor akCaster)

	utility.wait(0.1)

	Player = Game.GetPlayer()	
	RegisterForSingleUpdate(0.1)
	
EndEvent

Event OnUpdate()

	TransportArrow  = Game.FindClosestReferenceOfTypeFromRef(myProjectile, Player, 10000.0)
	TransportTarget  = Game.FindClosestReferenceOfTypeFromRef(myExplosion, Player, 10000.0)

	if (TransportArrow !=  None)

		RegisterForSingleUpdate(0.1)

	else

		if(TransportTarget != None)
		
			myTimeWarpSpell.Cast(Player)

			myVisualEffect.Play(Player, 0.5, TransportTarget)

			TransportTarget.PlaceAtMe(mySummonFX)

			utility.wait(0.25)

			Player.TranslateToRef(TransportTarget, 1800.0)

		endif

	endif

EndEvent

Event OnTranslationFailed()

	Debug.Notification("Levitation did not reach target")
	
	Player.StopTranslation()

	TransportTarget.Delete()
	TransportTarget  = None

EndEvent

Event OnTranslationAlmostComplete()


EndEvent


Event OnTranslationComplete()
	
	TransportTarget.Delete()
	TransportTarget  = None

	Game.AdvanceSkill("alteration",skillAdvancement)

EndEvent

Event  OnEffectFinish(Actor akTarget, Actor akCaster)
	
	UnRegisterForUpdate()
	Game.GetPlayer().StopTranslation()

	TransportTarget.Delete()
	TransportTarget  = None

EndEvent

